console.log( 'data.js' );

var colorNames =          [ 'none', 'white', 'green',   'pink',        'yellow',   'blue',     'orange' ] ;
var colorCodes =          [ '',   '#FFFFFF', '#dcedc8', '#f8bbd0',     '#fff9c4',  '#bbdefb', '#ffe0b2' ];
var otherSideColorCodes = [ '',   '#f5f5f5', '#f1f8e9', '#fce4ec',     '#fffde7',  '#e3f2fd', '#fff3e0']
var WHITE_COLOR_CODE = 1;

var SAMPLE_SET_ID = -1;
var SAMPLE_SET = {"id": SAMPLE_SET_ID,"name":"Sample Set","description":null,"idOnStudyStack":"1","category":"1","lastModOnStudyStack":"2014-08-29 01:57:39","dirty":false,"lastUsed":null,"createTime":"2001-12-01 00:00:00","numCards":50,"nextCardId":50,"options":"5RX","color":1,"finishedActivities":"","rows":[{"cardId":0,"dataElements":{"f1":{"id":1,"value":"Alabama","position":-1,"cardIdOnStudyStack":1,"dirty":0},"f2":{"id":2,"value":"Montgomery","position":-1,"cardIdOnStudyStack":1,"dirty":0}}},{"cardId":1,"dataElements":{"f1":{"id":3,"value":"Alaska","position":-1,"cardIdOnStudyStack":2,"dirty":0},"f2":{"id":4,"value":"Juneau","position":-1,"cardIdOnStudyStack":2,"dirty":0}}},{"cardId":2,"dataElements":{"f1":{"id":5,"value":"Arizona","position":-1,"cardIdOnStudyStack":3,"dirty":0},"f2":{"id":6,"value":"Phoenix","position":-1,"cardIdOnStudyStack":3,"dirty":0}}},{"cardId":3,"dataElements":{"f1":{"id":7,"value":"Arkansas","position":-1,"cardIdOnStudyStack":4,"dirty":0},"f2":{"id":8,"value":"Little Rock","position":-1,"cardIdOnStudyStack":4,"dirty":0}}},{"cardId":4,"dataElements":{"f1":{"id":9,"value":"California","position":-1,"cardIdOnStudyStack":5,"dirty":0},"f2":{"id":10,"value":"Sacramento","position":-1,"cardIdOnStudyStack":5,"dirty":0}}},{"cardId":5,"dataElements":{"f1":{"id":11,"value":"Colorado","position":-1,"cardIdOnStudyStack":6,"dirty":0},"f2":{"id":12,"value":"Denver","position":-1,"cardIdOnStudyStack":6,"dirty":0}}},{"cardId":6,"dataElements":{"f1":{"id":13,"value":"Connecticut","position":-1,"cardIdOnStudyStack":7,"dirty":0},"f2":{"id":14,"value":"Hartford","position":-1,"cardIdOnStudyStack":7,"dirty":0}}},{"cardId":7,"dataElements":{"f1":{"id":15,"value":"Delaware","position":-1,"cardIdOnStudyStack":8,"dirty":0},"f2":{"id":16,"value":"Dover","position":-1,"cardIdOnStudyStack":8,"dirty":0}}},{"cardId":8,"dataElements":{"f1":{"id":17,"value":"Florida","position":-1,"cardIdOnStudyStack":9,"dirty":0},"f2":{"id":18,"value":"Tallahassee","position":-1,"cardIdOnStudyStack":9,"dirty":0}}},{"cardId":9,"dataElements":{"f1":{"id":19,"value":"Georgia","position":-1,"cardIdOnStudyStack":10,"dirty":0},"f2":{"id":20,"value":"Atlanta","position":-1,"cardIdOnStudyStack":10,"dirty":0}}},{"cardId":10,"dataElements":{"f1":{"id":21,"value":"Hawaii","position":-1,"cardIdOnStudyStack":11,"dirty":0},"f2":{"id":22,"value":"Honolulu","position":-1,"cardIdOnStudyStack":11,"dirty":0}}},{"cardId":11,"dataElements":{"f1":{"id":23,"value":"Idaho","position":-1,"cardIdOnStudyStack":12,"dirty":0},"f2":{"id":24,"value":"Boise","position":-1,"cardIdOnStudyStack":12,"dirty":0}}},{"cardId":12,"dataElements":{"f1":{"id":25,"value":"Illinois","position":-1,"cardIdOnStudyStack":13,"dirty":0},"f2":{"id":26,"value":"Springfield","position":-1,"cardIdOnStudyStack":13,"dirty":0}}},{"cardId":13,"dataElements":{"f1":{"id":27,"value":"Indiana","position":-1,"cardIdOnStudyStack":14,"dirty":0},"f2":{"id":28,"value":"Indianapolis","position":-1,"cardIdOnStudyStack":14,"dirty":0}}},{"cardId":14,"dataElements":{"f1":{"id":29,"value":"Iowa","position":-1,"cardIdOnStudyStack":15,"dirty":0},"f2":{"id":30,"value":"Des Moines","position":-1,"cardIdOnStudyStack":15,"dirty":0}}},{"cardId":15,"dataElements":{"f1":{"id":31,"value":"Kansas","position":-1,"cardIdOnStudyStack":16,"dirty":0},"f2":{"id":32,"value":"Topeka","position":-1,"cardIdOnStudyStack":16,"dirty":0}}},{"cardId":16,"dataElements":{"f1":{"id":33,"value":"Kentucky","position":-1,"cardIdOnStudyStack":17,"dirty":0},"f2":{"id":34,"value":"Frankfort","position":-1,"cardIdOnStudyStack":17,"dirty":0}}},{"cardId":17,"dataElements":{"f1":{"id":35,"value":"Louisiana","position":-1,"cardIdOnStudyStack":18,"dirty":0},"f2":{"id":36,"value":"Baton Rouge","position":-1,"cardIdOnStudyStack":18,"dirty":0}}},{"cardId":18,"dataElements":{"f1":{"id":37,"value":"Maine","position":-1,"cardIdOnStudyStack":19,"dirty":0},"f2":{"id":38,"value":"Augusta","position":-1,"cardIdOnStudyStack":19,"dirty":0}}},{"cardId":19,"dataElements":{"f1":{"id":39,"value":"Maryland","position":-1,"cardIdOnStudyStack":20,"dirty":0},"f2":{"id":40,"value":"Annapolis","position":-1,"cardIdOnStudyStack":20,"dirty":0}}},{"cardId":20,"dataElements":{"f1":{"id":41,"value":"Massachusetts","position":-1,"cardIdOnStudyStack":21,"dirty":0},"f2":{"id":42,"value":"Boston","position":-1,"cardIdOnStudyStack":21,"dirty":0}}},{"cardId":21,"dataElements":{"f1":{"id":43,"value":"Michigan","position":-1,"cardIdOnStudyStack":22,"dirty":0},"f2":{"id":44,"value":"Lansing","position":-1,"cardIdOnStudyStack":22,"dirty":0}}},{"cardId":22,"dataElements":{"f1":{"id":45,"value":"Minnesota","position":-1,"cardIdOnStudyStack":23,"dirty":0},"f2":{"id":46,"value":"St. Paul","position":-1,"cardIdOnStudyStack":23,"dirty":0}}},{"cardId":23,"dataElements":{"f1":{"id":47,"value":"Mississippi","position":-1,"cardIdOnStudyStack":24,"dirty":0},"f2":{"id":48,"value":"Jackson","position":-1,"cardIdOnStudyStack":24,"dirty":0}}},{"cardId":24,"dataElements":{"f1":{"id":49,"value":"Missouri","position":-1,"cardIdOnStudyStack":25,"dirty":0},"f2":{"id":50,"value":"Jefferson City","position":-1,"cardIdOnStudyStack":25,"dirty":0}}},{"cardId":25,"dataElements":{"f1":{"id":51,"value":"Montana","position":-1,"cardIdOnStudyStack":26,"dirty":0},"f2":{"id":52,"value":"Helena","position":-1,"cardIdOnStudyStack":26,"dirty":0}}},{"cardId":26,"dataElements":{"f1":{"id":53,"value":"Nebraska","position":-1,"cardIdOnStudyStack":27,"dirty":0},"f2":{"id":54,"value":"Lincoln","position":-1,"cardIdOnStudyStack":27,"dirty":0}}},{"cardId":27,"dataElements":{"f1":{"id":55,"value":"Nevada","position":-1,"cardIdOnStudyStack":28,"dirty":0},"f2":{"id":56,"value":"Carson City","position":-1,"cardIdOnStudyStack":28,"dirty":0}}},{"cardId":28,"dataElements":{"f1":{"id":57,"value":"New Hampshire","position":-1,"cardIdOnStudyStack":29,"dirty":0},"f2":{"id":58,"value":"Concord","position":-1,"cardIdOnStudyStack":29,"dirty":0}}},{"cardId":29,"dataElements":{"f1":{"id":59,"value":"New Jersey","position":-1,"cardIdOnStudyStack":30,"dirty":0},"f2":{"id":60,"value":"Trenton","position":-1,"cardIdOnStudyStack":30,"dirty":0}}},{"cardId":30,"dataElements":{"f1":{"id":61,"value":"New Mexico","position":-1,"cardIdOnStudyStack":31,"dirty":0},"f2":{"id":62,"value":"Santa Fe","position":-1,"cardIdOnStudyStack":31,"dirty":0}}},{"cardId":31,"dataElements":{"f1":{"id":63,"value":"New York","position":-1,"cardIdOnStudyStack":32,"dirty":0},"f2":{"id":64,"value":"Albany","position":-1,"cardIdOnStudyStack":32,"dirty":0}}},{"cardId":32,"dataElements":{"f1":{"id":65,"value":"North Carolina","position":-1,"cardIdOnStudyStack":33,"dirty":0},"f2":{"id":66,"value":"Raleigh","position":-1,"cardIdOnStudyStack":33,"dirty":0}}},{"cardId":33,"dataElements":{"f1":{"id":67,"value":"North Dakota","position":-1,"cardIdOnStudyStack":34,"dirty":0},"f2":{"id":68,"value":"Bismarck","position":-1,"cardIdOnStudyStack":34,"dirty":0}}},{"cardId":34,"dataElements":{"f1":{"id":69,"value":"Ohio","position":-1,"cardIdOnStudyStack":35,"dirty":0},"f2":{"id":70,"value":"Columbus","position":-1,"cardIdOnStudyStack":35,"dirty":0}}},{"cardId":35,"dataElements":{"f1":{"id":71,"value":"Oklahoma","position":-1,"cardIdOnStudyStack":36,"dirty":0},"f2":{"id":72,"value":"Oklahoma City","position":-1,"cardIdOnStudyStack":36,"dirty":0}}},{"cardId":36,"dataElements":{"f1":{"id":73,"value":"Oregon","position":-1,"cardIdOnStudyStack":37,"dirty":0},"f2":{"id":74,"value":"Salem","position":-1,"cardIdOnStudyStack":37,"dirty":0}}},{"cardId":37,"dataElements":{"f1":{"id":75,"value":"Pennsylvania","position":-1,"cardIdOnStudyStack":38,"dirty":0},"f2":{"id":76,"value":"Harrisburg","position":-1,"cardIdOnStudyStack":38,"dirty":0}}},{"cardId":38,"dataElements":{"f1":{"id":77,"value":"Rhode Island","position":-1,"cardIdOnStudyStack":39,"dirty":0},"f2":{"id":78,"value":"Providence","position":-1,"cardIdOnStudyStack":39,"dirty":0}}},{"cardId":39,"dataElements":{"f1":{"id":79,"value":"South Carolina","position":-1,"cardIdOnStudyStack":40,"dirty":0},"f2":{"id":80,"value":"Columbia","position":-1,"cardIdOnStudyStack":40,"dirty":0}}},{"cardId":40,"dataElements":{"f1":{"id":81,"value":"South Dakota","position":-1,"cardIdOnStudyStack":41,"dirty":0},"f2":{"id":82,"value":"Pierre","position":-1,"cardIdOnStudyStack":41,"dirty":0}}},{"cardId":41,"dataElements":{"f1":{"id":83,"value":"Tennessee","position":-1,"cardIdOnStudyStack":42,"dirty":0},"f2":{"id":84,"value":"Nashville","position":-1,"cardIdOnStudyStack":42,"dirty":0}}},{"cardId":42,"dataElements":{"f1":{"id":85,"value":"Texas","position":-1,"cardIdOnStudyStack":43,"dirty":0},"f2":{"id":86,"value":"Austin","position":-1,"cardIdOnStudyStack":43,"dirty":0}}},{"cardId":43,"dataElements":{"f1":{"id":87,"value":"Utah","position":-1,"cardIdOnStudyStack":44,"dirty":0},"f2":{"id":88,"value":"Salt Lake City","position":-1,"cardIdOnStudyStack":44,"dirty":0}}},{"cardId":44,"dataElements":{"f1":{"id":89,"value":"Vermont","position":-1,"cardIdOnStudyStack":45,"dirty":0},"f2":{"id":90,"value":"Montpelier","position":-1,"cardIdOnStudyStack":45,"dirty":0}}},{"cardId":45,"dataElements":{"f1":{"id":91,"value":"Virginia","position":-1,"cardIdOnStudyStack":46,"dirty":0},"f2":{"id":92,"value":"Richmond","position":-1,"cardIdOnStudyStack":46,"dirty":0}}},{"cardId":46,"dataElements":{"f1":{"id":93,"value":"Washington","position":-1,"cardIdOnStudyStack":47,"dirty":0},"f2":{"id":94,"value":"Olympia","position":-1,"cardIdOnStudyStack":47,"dirty":0}}},{"cardId":47,"dataElements":{"f1":{"id":95,"value":"West Virginia","position":-1,"cardIdOnStudyStack":48,"dirty":0},"f2":{"id":96,"value":"Charleston","position":-1,"cardIdOnStudyStack":48,"dirty":0}}},{"cardId":48,"dataElements":{"f1":{"id":97,"value":"Wisconsin","position":-1,"cardIdOnStudyStack":49,"dirty":0},"f2":{"id":98,"value":"Madison","position":-1,"cardIdOnStudyStack":49,"dirty":0}}},{"cardId":49,"dataElements":{"f1":{"id":99,"value":"Wyoming","position":-1,"cardIdOnStudyStack":50,"dirty":0},"f2":{"id":100,"value":"Cheyenne","position":-1,"cardIdOnStudyStack":50,"dirty":0}}}],"fields":[{"id":1,"name":"State","idOnStudyStack":1,"dirty":0,"deleted":null},{"id":2,"name":"Capital","idOnStudyStack":2,"dirty":0,"deleted":null}]};

// obtained from http://www.studystack.com/servlet/categoryListJson?strict=Y&order=hierarchical
var CATEGORY_LIST=[ { "id" : 98, "name" : "Agriculture", "url" : "agriculture", "parentId" : 0}, { "id" : 60, "name" : "Business", "url" : "Business", "parentId" : 0}, { "id" : 44, "name" : "Accounting", "url" : "Accounting", "parentId" : 60}, { "id" : 126, "name" : "Economics", "url" : "economics", "parentId" : 60}, { "id" : 66, "name" : "Finance", "url" : "Finance", "parentId" : 60}, { "id" : 102, "name" : "Insurance", "url" : "insurance", "parentId" : 60}, { "id" : 68, "name" : "Management", "url" : "Management", "parentId" : 60}, { "id" : 67, "name" : "Marketing", "url" : "Marketing", "parentId" : 60}, { "id" : 69, "name" : "Real Estate", "url" : "RealEstate", "parentId" : 60}, { "id" : 1, "name" : "Geography", "url" : "Geography", "parentId" : 0}, { "id" : 38, "name" : "AP Human Geography", "url" : "APHumanGeography", "parentId" : 1}, { "id" : 3, "name" : "History", "url" : "History", "parentId" : 0}, { "id" : 88, "name" : "American Government", "url" : "AmericanGovernment", "parentId" : 3}, { "id" : 47, "name" : "AP Comparative Gov.", "url" : "APComparativeGov", "parentId" : 3}, { "id" : 55, "name" : "European History", "url" : "EuropeanHistory", "parentId" : 3}, { "id" : 52, "name" : "Religion", "url" : "Religion", "parentId" : 3}, { "id" : 15, "name" : "U.S. History", "url" : "USHistory", "parentId" : 3}, { "id" : 33, "name" : "World History", "url" : "WorldHistory", "parentId" : 3}, { "id" : 6, "name" : "Languages", "url" : "Languages", "parentId" : 0}, { "id" : 100, "name" : "Arabic", "url" : "arabic", "parentId" : 6}, { "id" : 72, "name" : "Bisaya", "url" : "Bisaya", "parentId" : 6}, { "id" : 50, "name" : "Chinese", "url" : "Chinese", "parentId" : 6}, { "id" : 71, "name" : "Czech", "url" : "Czech", "parentId" : 6}, { "id" : 119, "name" : "Dene", "url" : "Dene", "parentId" : 6}, { "id" : 94, "name" : "Dutch", "url" : "dutch", "parentId" : 6}, { "id" : 21, "name" : "English Verbs", "url" : "EnglishVerbs", "parentId" : 6}, { "id" : 12, "name" : "English Vocabulary", "url" : "EnglishVocab", "parentId" : 6}, { "id" : 112, "name" : "Academic Vocabulary", "url" : "AcademicVocabulary", "parentId" : 12}, { "id" : 41, "name" : "Stadlier Oxford Voca", "url" : "StadlierOxfordVocab", "parentId" : 12}, { "id" : 23, "name" : "Walk Two Moons", "url" : "WalkTwoMoons", "parentId" : 12}, { "id" : 56, "name" : "Esperanto", "url" : "Esperanto", "parentId" : 6}, { "id" : 58, "name" : "Finnish", "url" : "Finnish", "parentId" : 6}, { "id" : 13, "name" : "French", "url" : "French", "parentId" : 6}, { "id" : 27, "name" : "German", "url" : "German", "parentId" : 6}, { "id" : 39, "name" : "Greek", "url" : "Greek", "parentId" : 6}, { "id" : 95, "name" : "Hebrew", "url" : "hebrew", "parentId" : 6}, { "id" : 32, "name" : "Italian", "url" : "Italian", "parentId" : 6}, { "id" : 42, "name" : "Japanese", "url" : "Japanese", "parentId" : 6}, { "id" : 121, "name" : "Kazakh", "url" : "Kazakh", "parentId" : 6}, { "id" : 30, "name" : "Korean", "url" : "Korean", "parentId" : 6}, { "id" : 24, "name" : "Latin", "url" : "Latin", "parentId" : 6}, { "id" : 25, "name" : "Literature", "url" : "Literature", "parentId" : 6}, { "id" : 122, "name" : "Polish", "url" : "Polish", "parentId" : 6}, { "id" : 49, "name" : "Portuguese", "url" : "Portuguese", "parentId" : 6}, { "id" : 54, "name" : "Reading", "url" : "Reading", "parentId" : 6}, { "id" : 28, "name" : "Russian", "url" : "Russian", "parentId" : 6}, { "id" : 57, "name" : "Slovak", "url" : "Slovak", "parentId" : 6}, { "id" : 14, "name" : "Spanish", "url" : "Spanish", "parentId" : 6}, { "id" : 128, "name" : "Swahili", "url" : "Swahili", "parentId" : 6}, { "id" : 105, "name" : "Swedish", "url" : "swedish", "parentId" : 6}, { "id" : 117, "name" : "Turkish", "url" : "Turkish", "parentId" : 6}, { "id" : 101, "name" : "Welsh", "url" : "Welsh", "parentId" : 6}, { "id" : 110, "name" : "Writing", "url" : "writing", "parentId" : 6}, { "id" : 125, "name" : "Yiddish", "url" : "Yiddish", "parentId" : 6}, { "id" : 107, "name" : "Law", "url" : "law", "parentId" : 0}, { "id" : 8, "name" : "Math", "url" : "Math", "parentId" : 0}, { "id" : 2, "name" : "Medical", "url" : "Medical", "parentId" : 0}, { "id" : 48, "name" : "Acupuncture", "url" : "Acupuncture", "parentId" : 2}, { "id" : 16, "name" : "Anatomy", "url" : "Anatomy", "parentId" : 2}, { "id" : 73, "name" : "Bacteriology", "url" : "Bacteriology", "parentId" : 2}, { "id" : 76, "name" : "Biochemistry", "url" : "Biochemistry", "parentId" : 2}, { "id" : 46, "name" : "Chiropractic", "url" : "Chiropractic", "parentId" : 2}, { "id" : 80, "name" : "Clinical Skills", "url" : "ClinicalSkills", "parentId" : 2}, { "id" : 93, "name" : "Dentistry", "url" : "dentistry", "parentId" : 2}, { "id" : 118, "name" : "EEG", "url" : "EEG", "parentId" : 2}, { "id" : 78, "name" : "Genetics", "url" : "Genetics", "parentId" : 2}, { "id" : 87, "name" : "Health & Social Care", "url" : "HealthCare", "parentId" : 2}, { "id" : 79, "name" : "Histology", "url" : "Histology", "parentId" : 2}, { "id" : 51, "name" : "Laboratory Science", "url" : "LaboratoryScience", "parentId" : 2}, { "id" : 26, "name" : "Massage Therapy", "url" : "MassageTherapy", "parentId" : 2}, { "id" : 99, "name" : "Midwifery", "url" : "midwifery", "parentId" : 2}, { "id" : 89, "name" : "Neuroscience", "url" : "Neuroscience", "parentId" : 2}, { "id" : 22, "name" : "Nursing", "url" : "Nursing", "parentId" : 2}, { "id" : 82, "name" : "Occupational Therapy", "url" : "OccupationalTherapy", "parentId" : 2}, { "id" : 77, "name" : "Osteopathic Principl", "url" : "OsteopathicPrinciples", "parentId" : 2}, { "id" : 31, "name" : "Paramedic/EMT", "url" : "ParamedicEMT", "parentId" : 2}, { "id" : 20, "name" : "Pharmacology", "url" : "Pharmacology", "parentId" : 2}, { "id" : 90, "name" : "Phlebotomy", "url" : "Phlebotomy", "parentId" : 2}, { "id" : 43, "name" : "Physical Therapy", "url" : "PhysicalTherapy", "parentId" : 2}, { "id" : 70, "name" : "Physiology", "url" : "Physiology", "parentId" : 2}, { "id" : 29, "name" : "Psychology", "url" : "Psychology", "parentId" : 2}, { "id" : 116, "name" : "Radiation Therapy", "url" : "RadiationTherapy", "parentId" : 2}, { "id" : 53, "name" : "Radiology", "url" : "Radiology", "parentId" : 2}, { "id" : 45, "name" : "Respiratory Therapy", "url" : "RespiratoryTherapy", "parentId" : 2}, { "id" : 115, "name" : "Sonography", "url" : "sonography", "parentId" : 2}, { "id" : 74, "name" : "Speech Therapy", "url" : "SpeechTherapy", "parentId" : 2}, { "id" : 40, "name" : "Sports Medicine", "url" : "SportsMedicine", "parentId" : 2}, { "id" : 103, "name" : "Surgery", "url" : "surgery", "parentId" : 2}, { "id" : 83, "name" : "Veterinary", "url" : "Veterinary", "parentId" : 2}, { "id" : 7, "name" : "Miscellaneous", "url" : "Miscellaneous", "parentId" : 0}, { "id" : 104, "name" : "Aviation", "url" : "aviation", "parentId" : 7}, { "id" : 17, "name" : "Computers", "url" : "Computers", "parentId" : 7}, { "id" : 96, "name" : "Culinary Arts", "url" : "culinary", "parentId" : 7}, { "id" : 123, "name" : "Family and Consumer ", "url" : "Family", "parentId" : 7}, { "id" : 127, "name" : "Fitness", "url" : "fitness", "parentId" : 7}, { "id" : 92, "name" : "Graphic Arts", "url" : "GraphicArts", "parentId" : 7}, { "id" : 81, "name" : "Library Media", "url" : "LibraryMedia", "parentId" : 7}, { "id" : 85, "name" : "Military", "url" : "Military", "parentId" : 7}, { "id" : 86, "name" : "Marine Sci Tech 1", "url" : "MarineScienceTech1", "parentId" : 85}, { "id" : 124, "name" : "Music", "url" : "music", "parentId" : 7}, { "id" : 34, "name" : "Quiz Bowl", "url" : "QuizBowl", "parentId" : 7}, { "id" : 129, "name" : "Social Studies", "url" : "SocialStudies", "parentId" : 7}, { "id" : 5, "name" : "Sports", "url" : "Sports", "parentId" : 7}, { "id" : 4, "name" : "Science", "url" : "Science", "parentId" : 0}, { "id" : 106, "name" : "Anthropology", "url" : "anthropology", "parentId" : 4}, { "id" : 18, "name" : "Biology", "url" : "Biology", "parentId" : 4}, { "id" : 19, "name" : "Chemistry", "url" : "Chemistry", "parentId" : 4}, { "id" : 35, "name" : "Earth Science", "url" : "EarthScience", "parentId" : 4}, { "id" : 111, "name" : "Engineering", "url" : "Engineering", "parentId" : 4}, { "id" : 37, "name" : "Physical Science", "url" : "PhysicalScience", "parentId" : 4}, { "id" : 36, "name" : "Physics", "url" : "Physics", "parentId" : 4}, { "id" : 59, "name" : "Standardized Tests", "url" : "StandardizedTests", "parentId" : 0}, { "id" : 113, "name" : "ACT", "url" : "ACT", "parentId" : 59}, { "id" : 97, "name" : "CPS/CAP", "url" : "CPSCAP", "parentId" : 59}, { "id" : 91, "name" : "DAT", "url" : "DAT", "parentId" : 59}, { "id" : 64, "name" : "GMAT", "url" : "GMAT", "parentId" : 59}, { "id" : 61, "name" : "GRE", "url" : "GRE", "parentId" : 59}, { "id" : 65, "name" : "LSAT", "url" : "LSAT", "parentId" : 59}, { "id" : 63, "name" : "MCAT", "url" : "MCAT", "parentId" : 59}, { "id" : 120, "name" : "RICA", "url" : "RICA", "parentId" : 59}, { "id" : 62, "name" : "SAT", "url" : "SAT", "parentId" : 59}, { "id" : 114, "name" : "TOEFL", "url" : "TOEFL", "parentId" : 59}, { "id" : 75, "name" : "USMLE", "url" : "USMLE", "parentId" : 59}];
var CATEGORIES = [];
var UNFINISHED_CATEGORY = 9;
var HIDDEN_CATEGORY = 11;
var PRIVATE_CATEGORY = 132;

function initCategoryArray() {
  for ( var i=0; i<CATEGORY_LIST.length; i++ ) {
      var category = CATEGORY_LIST[i] ;
      CATEGORIES[ category.id ] = category ;
  }
}

initCategoryArray();
 
function getCategory( id ) {
   if ( id >=CATEGORIES.length || !CATEGORIES[id] ) {
        CATEGORIES[ id ] = { "id" : id, "name": "Unknown Category " + id, "url" : null, "parentId" : 0} ;
   }
   
   return CATEGORIES[ id ];
}


function getCategoryOptionHtml() {
	var catHtml = '' ;
	for ( var catIndex=0; catIndex<CATEGORY_LIST.length; catIndex++ ) {
	    var name = '';
	    var category = CATEGORY_LIST[ catIndex ];
	    var tmpCat = category;
	    while (tmpCat.parentId != 0 ) {
	        name += '-- ';
	        tmpCat = CATEGORIES[ tmpCat.parentId ]; 
	    }
	    name += category.name ;
	    
	    catHtml += '<option value="' +  category.id  + '">' + name + '</option>' ;
	}
    return catHtml ;
}


function createStackFromJson( json ) {
   if ( !json ) {
       return null ;
   }
   var stack = new StudyStack();
   for ( prop in json ) {
       stack[prop] = json[prop] ;
   }    
   stack.rows = [];
   stack.fields = [];
   for ( var f = 0; f<json.fields.length; f++ ) {
	   var jsonField = json.fields[f];
	   var field = new StudyField( jsonField.id, jsonField.name, jsonField.idOnStudyStack, jsonField.dirty );
	   stack.addField( field ); 
   }
   for ( var r = 0; r<json.rows.length; r++ ) {
  	   var jsonRow = json.rows[r];
	   var stackRow = new StudyStackRow( jsonRow.cardId, jsonRow.position );
	   stackRow.dataElements = jsonRow.dataElements ;
	   stack.rows[ stack.rows.length ] = stackRow ;
   }
   return stack;
}


function StudyStack ( id, name, description, idOnStudyStack, category, lastModOnStudyStack, dirty, lastUsed, createdBy, createTime, numCards, nextCardId, options, color, finishedActivities ) {
    if ( category <= 0 ) {
         category = UNFINISHED_CATEGORY ;
    }
    
    this.id = id ;
    this.name = name ;
    this.description = description ;
    this.idOnStudyStack = idOnStudyStack ;
    this.category = category ;
    this.lastModOnStudyStack = lastModOnStudyStack ;
    this.dirty = !!dirty ;
    this.lastUsed = lastUsed ;
    this.createTime = createTime ;
    this.numCards = numCards ;
    this.nextCardId = nextCardId ;
    this.options = options ;
    this.color = ((color>0 && color < colorNames.length ) ? color : WHITE_COLOR_CODE);
    this.finishedActivities = finishedActivities ;
    if ( !this.finishedActivities ) {
        this.finishedActivities = '' ;
    }
    this.rows = [];  // ordered by position
    this.fields = [];
    
    
    this.dump = function() {
         for ( var i=0; i<this.rows.length; i++ ) {
              var row = this.rows[ i ];
              var buf = i + 'row cardId=' + row.cardId + ':  ';
              
              for ( var f=0; f<this.getNumSides(); f++ ) {
                  var field = this.fields[f] ;
                  var dataElement = row.getDataElement( field.id );
                  buf = buf + field.id + ' ' + dataElement.value + '     ' ;
              }
              console.log( buf );
         }
    }
    
    this.getNumCards = function() {
        return this.rows.length ;
    }
    
    this.getNumSides = function() {
        return this.fields.length ;
    }
    
    this.getFieldByServerId = function(serverId) {
    	for ( var f=0; f<this.fields.length; f++ ) {
    		var field = this.fields[f] ;
    		if ( field.idOnStudyStack == serverId ) {
    			return field ;
    		}
    	}
    	return null ;
    }
    
    this.getCardSide = function( rowIndex, sideIndex ) {
        var row = this.rows[ rowIndex ];
        var field = this.fields[ sideIndex ] ;
        if ( !field || !row ) {
        	return "" ;
        }
        else {
        	return row.getDataElement( field.id  ).value ;
        }
    } 
    
    this.hasFinishedActivity = function ( activityCode ) {
        return this.finishedActivities.indexOf( activityCode ) >= 0 ;
    }
    
    this.finishActivity = function( activityCode ) {
        var code = '' + activityCode ;
        if ( !this.hasFinishedActivity( code ) ) {
             this.finishedActivities += code ;
             dataManager.updateField( "studystack", "finishedActivities", this.finishedActivities, this.id );
             refreshTitle();
             beep();
        }
    }
    
    
    this.getRow = function( rowIndex ) {
        return this.rows[ rowIndex ];
    }
    
    this.findRowByServerCardId = function ( serverCardId ) {
          for ( var index=0; index<this.numCards; index++ ) {
               var row = this.getRow( index );
               if ( row && row.getCardIdOnStudyStack() == serverCardId ) {
               	   return row ;
               } 
          }
          return null ;
    } 
    
    this.getRowByCardId = function ( cardId ) {
          if ( cardId >= 0 ) {
	          for ( var index=0; index<this.numCards; index++ ) {
	               var row = this.getRow( index );
	               if ( row && row.cardId == cardId ) {
	               	   return row ;
	               } 
	          }
          }
          if ( cardId < 0 ) {
              cardId = parseFloat( this.nextCardId );
          }
          row = new StudyStackRow( cardId, this.rows.length );
          
          var newIndex = this.rows.length ;
/*          
          while ( newIndex > 0 && this.rows[ newIndex-1 ].cardId > cardId ) {
               newIndex--;
          }
*/          
          this.rows.splice( newIndex, 0, row );
          
          if ( cardId >= this.nextCardId ) {
              this.nextCardId = cardId + 1 ;
           	  dataManager.updateField( 'studystack', 'nextCardId', this.nextCardId, this.id );
              this.markDirty();
          }
          if ( this.numCards < this.rows.length ) {
		      this.updateNumCards();
          }
          return row ;
    }
	
	this.updateNumCards = function() {
          if ( this.numCards != this.rows.length ) {
               this.numCards = this.rows.length ;
               var stack = this ;
               setTimeout( function() {
	               dataManager.updateField( 'studystack', 'numCards', stack.numCards, stack.id );
               	   stack.markDirty();
               	}, 0 );
          }
	}
    
    this.deleteRow = function( cardId ) {
          for ( var i=0; i<this.rows.length; i++ ) {
              if ( this.rows[i] != null && this.rows[i].cardId == cardId ) {
                  this.rows.splice( i, 1 );
                  break; ; 
              }
          }
		  this.updateNumCards();
		  this.markDirty();
    }
    
    this.addField = function ( field ) {
	    this.fields[ this.getNumSides() ] = field ;
    }
    
    this.markDirty = function () {
         if ( ! this.dirty ) {
              dataManager.updateField( 'studystack', 'dirty', 1, this.id );
              this.dirty = true ;
              if ( studyStack != null && studyStack.id == this.id ) {
              	   studyStack.dirty = true ;
              }
         }
    }

    this.markClean = function () {
         if ( this.dirty ) {
              //dataManager.updateField( 'studystack', 'dirty', 0, this.id );
              dataManager.clearStacksDirtyFlags( this.id );
              this.dirty = false ;
              if ( studyStack != null && studyStack.id == this.id ) {
              	   studyStack.dirty = false ;
              }
         }
    }



	this.loadWords = function( minWords, maxWords, wordLoader ) {
	   var unusedRows = [];
	   var r,c;
	   var wordsFound = 0;
	   
       // loop through the rows in random order
	   var randomArray = createShuffledIntArray( this.numCards );
	   for ( r=this.numCards-1; r>=0 && wordsFound<maxWords; r-- ) {
	      var rowIndex = randomArray[r]; 
          var row = this.getRow( rowIndex );
		  if ( !row ) {
		  	  console.log( 'what happened!!!' );
		  }
          var randomColArray = createShuffledIntArray( this.getNumSides() );
          for ( c=this.getNumSides()-1; c>=0 && wordsFound<maxWords; c-- ) {
		       var word = "";
		       var hint = "";
		       var col = randomColArray[c] ;
		       var field = this.fields[ col ] ;
		       
	           var value = row.getDataElement( field.id ).value ;
			   var valueLength = value.length ;
		
			   // try to use the whole value as the word
	 	       word = value; 
	 	       var hintCol = (col==0 && this.getNumSides()>1) ? 1 : 0;
	 	        
	 	       hint = row.getDataElement( this.fields[ hintCol ].id ).value ; 
	           if ( (word.indexOf( "__" ) == -1) && wordLoader.addWord( word, hint ) ) {
	               wordsFound++ ;
	               break;
	           }
	           else {
	                unusedRows[ unusedRows.length ] = rowIndex ; 
	           }
	       } // end for c
	    } // end for r
	    
	    console.log( "loadWords found " + wordsFound + " words minWords=" + minWords );
	    if ( wordsFound < minWords ) {
	          this.loadFillInTheBlankWords( maxWords - wordsFound, unusedRows, wordLoader );
	    }
	    
	 }  // end loadWords()


	this.loadFillInTheBlankWords = function( maxWords, rowIndexes, wordLoader ) {
	     var wordsFound = 0;
	     var minLength = 6;
	     var r,c;
	     for ( r=0; r<rowIndexes.length && wordsFound<maxWords; r++ ) {
	         var rowIndex = rowIndexes[r];
             var row = this.getRow( rowIndex );
	         
             var randomColArray = createShuffledIntArray( this.getNumSides());
             for ( c=this.getNumSides()-1; c>=0 && wordsFound<maxWords; c-- ) {
		         var word = "";
		         var hint = "";
		         var col = randomColArray[c] ;
		         var field = this.fields[ col ] ;
		       
	             var value = row.getDataElement( field.id ).value ;
	             if ( value.indexOf( "__" ) == -1 && value.length > minLength ) {
                     // look for a long word within this value
                     var pos = Math.floor( Math.random() * (value.length-minLength) );
                     var foundOne = false ;
                     while ( pos>=0 && pos < value.length && !foundOne ) {
                            pos = value.indexOf( ' ', pos );
                            if ( pos >= 0 ) {
                                var start = pos + 1 ;
                                pos = value.indexOf( ' ', start );
                                var end = ( pos < 0 ) ? value.length : pos ;
                                if ( end - start > minLength ) {
                                    word = value.substring( start, end );
                                    word = removePunctuation( word );
                                    if ( word.length > minLength ) {
                                       hint = value.substring( 0, start) + "_____" + value.substring( end );
                                       foundOne = wordLoader.addWord( word, hint );
                                    }
                                }
                                pos = end + 1;
                             }
                     } // end while
                 } // end if
   	       } // end for c 
	   } // end for r
    } // end loadFillInTheBlankWords
    
    
    this.getDirtyJson = function() {
        var stack = getNewStudyStack();
        
        stack.id = this.id ;
        stack.name = this.name ;
        stack.description = this.description ;
        stack.idOnStudyStack = this.idOnStudyStack ;
        stack.category = this.category ;
        stack.lastModOnStudyStack = this.lastModOnStudyStack ;
        stack.dirty = this.dirty ;
        stack.lastUsed = this.lastUsed ;
        stack.createTime = this.createTime ;
        stack.numCards = this.numCards ;
        stack.rows = [];
        stack.fields = this.fields;
        
        var i;
        for ( i=0; i<this.rows.length; i++ ) {
            var row = this.rows[ i ];
            if ( row.isDirty() ) {
                var newRow = new StudyStackRow( row.cardId, row.position );
                
		        for ( var elemName in row.dataElements ) {
		            var elem = row.dataElements[ elemName ];
		            if ( elem.dirty ) {
		            	newRow.dataElements[ elemName ] = elem ;
		            }
		        }
                
                stack.rows[ stack.rows.length ] = newRow ;
            }
        }
        
        var json = JSON.stringify( stack );
//		console.log( 'getDirtyJson returning' + json );
        return json ; 
    }
    
} // end StudyStack


function getNewStudyStack() {
    return new StudyStack( '',    // id
                           '',    // name
                           '',    // description 
                           -1,    // idOnStudyStack
                           -1,    // category 
                           '',    // lastModOnStudyStack 
                           false, // dirty
                           '',    // lastUsed
                           -1,    // createdBy
                           '',    // createTime
                            0,    // numCards
                            1,    // nextCardId
                           '',    // options
                           '',    // color
                           '' );  // finishedActivities
}

function makeStackFromResultSet( resultSet ) {
    return new StudyStack( resultSet.id, resultSet.name, resultSet.description, resultSet.idOnStudyStack, resultSet.category, resultSet.lastModOnStudyStack, resultSet.dirty==1, resultSet.lastUsed, 
    						resultSet.createdBy, resultSet.createTime, resultSet.numCards, resultSet.nextCardId, resultSet.options, resultSet.color, resultSet.finishedActivities );
}



function StudyField( id, name, idOnStudyStack, dirty, deleted ) {
    this.id = id ;
    this.name = name ;
    this.idOnStudyStack = idOnStudyStack ;
    this.dirty = dirty ;
    this.deleted = deleted ;
}

function makeStudyFieldFromResultSet( resultSet ) {
    return new StudyField( resultSet.id, resultSet.name, resultSet.idOnStudyStack, resultSet.dirty, resultSet.deleted );
}



function StudyStackRow( cardId, position ) {
    this.cardId = cardId ;
    this.position = position ;
    this.dataElements = {};
    
    this.addDataElement = function ( fieldId, dataElement ) {
         this.dataElements[ 'f' + fieldId ] = dataElement ;
    }
    
    this.getDataElement = function ( fieldId ) {
          if ( !this.dataElements[ 'f' + fieldId ] ) {
              var newDataElement = new DataElement( -1, '', -1, -1, true );
              this.addDataElement( fieldId, newDataElement );
          } 
          return this.dataElements[ 'f' + fieldId ];
    }
    
    this.isDirty = function () {
        for ( var elemName in this.dataElements ) {
            var elem = this.dataElements[ elemName ];
            if ( elem.dirty ) {
                return true;
            }
        }
        return false ;
    }
    
    this.getCardIdOnStudyStack = function() {
        for ( var elemName in this.dataElements ) {
            var elem = this.dataElements[ elemName ];
            return elem.cardIdOnStudyStack ;
        }
        return -1;
    }
    
} 


function DataElement( id, value, position, cardIdOnStudyStack, dirty, deleted ){
   this.id = id;
   this.value = value ;
   this.position = position ;
   this.cardIdOnStudyStack = cardIdOnStudyStack ;
   this.dirty = dirty ;
   this.deleted = deleted ;
}
            
 function makeDataElementFromResultSet( resultSet ) {
        return new DataElement( resultSet.id, resultSet.value, resultSet.position, resultSet.cardIdOnStudyStack, resultSet.dirty, resultSet.deleted );
 }
